from enum import Enum
from typing import List, Optional

from llhardware._cpp import core

class I2C:
    file_name: str
    def __init__(self, filename: str) -> None: ...
    def close(self) -> None: ...
    def scan(self, first: int, last: int, mode: int) -> List[int]: ...

class I2CDevice:
    def __init__(self, core: I2C, addr: int) -> None: ...
    def read_byte(self) -> int: ...
    def write_byte(self, value: int) -> None: ...
    def read_byte_data(self, command: int) -> int: ...
    def write_byte_data(self, command: int, value: int) -> None: ...
    def read_word_data(self, command: int) -> int: ...
    def write_word_data(self, command: int, value: int) -> None: ...
    def read_block_data(self, command: int, length: int) -> bytes: ...
    def write_block_data(self, command: int, data: bytes) -> None: ...

class GPIO:
    class GPIOMode(Enum):
        GPIO_MODE = ...
        PINS_MODE = ...
        PHYS_MODE = ...

    class DigitalValue(Enum):
        LOW = ...
        HIGH = ...

    class PullMode(Enum):
        PUD_OFF = ...
        PUD_DOWN = ...
        PUD_UP = ...

    class InterruptMode(Enum):
        NONE = ...
        FALLING = ...
        RISING = ...
        BOTH = ...

    class IPin:
        @property
        def pin(self) -> int: ...

    class IDigitalReadPin(IPin):
        def digital_read(self) -> GPIO.DigitalValue: ...

    class IPullUpDnControlPin(IPin):
        def pull_control(self, mode: GPIO.PullMode) -> None: ...

    class IDigitalInterruptPin(IPin):
        @property
        def interrupt_stream(self) -> core.Stream: ...
        def setup_interrupt(self, mode: GPIO.InterruptMode) -> None: ...

    class IDigitalWritePin(IPin):
        def digital_write(self, value: GPIO.DigitalValue) -> None: ...

    class MemInputPin(IDigitalReadPin, IPullUpDnControlPin): ...
    class MemOutputPin(IDigitalWritePin): ...
    class SysInputPin(IDigitalReadPin, IPullUpDnControlPin, IDigitalInterruptPin, core.IOUpdate): ...
    class SysOutputPin(IDigitalWritePin): ...

    def __init__(self, mode: GPIO.GPIOMode) -> None: ...
    def input(self, pin: int, inverse: bool) -> MemInputPin: ...
    def sys_input(self, pin: int, inverse: bool) -> SysInputPin: ...
    def output(self, pin: int, inverse: bool, init_value: DigitalValue) -> MemOutputPin: ...
    def sys_output(self, pin: int, inverse: bool, init_value: DigitalValue) -> SysOutputPin: ...

class IPWMPulseWidth:
    pulse_width: int
    def _get_pulse_width(self) -> int: ...
    def _set_pulse_width(self, width: int) -> None: ...

class IPWMFillFactor:
    fill_factor: float
    def _get_fill_factor(self) -> float: ...
    def _set_fill_factor(self, factor: float) -> None: ...

class SoftPWM(core.SimpleUpdate, IPWMPulseWidth, IPWMFillFactor):
    def __init__(self, pin: GPIO.IDigitalWritePin, pwm_period_ns: int) -> None: ...

class Serial:
    @property
    def fd(self) -> int: ...
    @property
    def filename(self) -> str: ...
    @property
    def baudrate(self) -> int: ...
    def __init__(self, filename: str, baudrate: int) -> None: ...
    def read(self, nbytes: int) -> bytes: ...
    def write(self, buf: bytes) -> int: ...
    def close(self) -> None: ...

class IBus(core.IOUpdate):
    @property
    def stream(self) -> core.Stream: ...
    def __init__(self, serial: Serial, channels: int, timeout_ns: int) -> None: ...

class RuOwen(core.IOUpdate):
    class PacketData:
        @property
        def addr(self) -> int: ...
        @property
        def read_or_write(self) -> bool: ...
        @property
        def cmd(self) -> int: ...
        @property
        def data(self) -> list[int]: ...

    @staticmethod
    def name2cmd(name: str) -> int: ...
    @property
    def addr_len_8(self) -> bool: ...
    def __init__(self, serial: Serial, addr_len_8: bool, timeout_ns: int) -> None: ...
    def make_packet(self, addr: int, read_or_write: bool, cmd: int, data: list[int]) -> str: ...
    def parse_packet(self, packet: str) -> PacketData: ...
    def send_packet(self, packet: str) -> core.Stream: ...
